/*
 *  This file is part of libosc++.
 *
 *  libosc++ is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  libosc++ is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesse General Public License
 *  along with libosc++.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright 2009 Cristian Maglie
 *
 *  Cristian Maglie <liboscpp@bug.st>
 *  http://bug.st/libosc++
 */

#ifndef INCLUDED_OSC_EXCEPTION_H
#define INCLUDED_OSC_EXCEPTION_H

#include <exception>

namespace osc {

class Exception : public std::exception {
public:
    Exception() throw() { }
    Exception(const Exception& _e) throw() : msg(_e.msg) { }
    Exception(const char *_msg) throw() : msg(_msg) { }
    Exception& operator=(const Exception& _e) throw() { msg = _e.msg; return *this; }
    virtual ~Exception() throw() { }
    virtual const char *what() const throw() { return msg; }

private:
    const char *msg;
};

} // namespace osc

#endif // INCLUDED_OSC_EXCEPTION_H

